<?php

class MyXMLReader extends XMLReader implements ArrayAccess
{
	function offsetSet($ofs, $value)
	{
		throw new Exception('Cannot set attributes');
	}

	function offsetUnset($ofs)
	{
		throw new Exception('Cannot unset attributes');
	}

	function offsetExists($ofs)
	{
		$result = false;
		if ($this->hasAttributes || $this->nodeType == self::ATTRIBUTE) {
			$n	= $this->nodeType == self::ATTRIBUTE
				? $tihs->name : NULL;
			$this->moveToElement();
			for ($p = $this->attributeCount; $p; ) {
				$this->moveToAttributeNo(--$p);
				if ($this->name == $ofs) {
					$result = true;
				}
			}
			if (isset($n)) {
				$this->moveToAttribute($n);
			} else {
				$this->moveToElement();
			}
		}
		return $result;
	}

	function offsetGet($ofs)
	{
		$result = NULL;
		if ($this->hasAttributes || $this->nodeType == self::ATTRIBUTE) {
			$n	= $this->nodeType == self::ATTRIBUTE
				? $tihs->name : NULL;
			$this->moveToElement();
			for ($p = $this->attributeCount; $p; ) {
				$this->moveToAttributeNo(--$p);
				if ($this->name == $ofs) {
					$result = $this->value;
				}
			}
			if (isset($n)) {
				$this->moveToAttribute($n);
			} else {
				$this->moveToElement();
			}
		}
		return $result;
	}
}

$reader = new MyXMLReader();
if ($reader->open($argv[1])) {
	while ($reader->read()) {
		if ($reader->nodeType == XMLReader::ELEMENT
		&& $reader->hasAttributes)
		{
			if (isset($reader['href']))
			{
				echo $reader['href'] . "\n";
			}
		}
	}
}
$reader->close();

?>